<template>
	<v-dialog
		v-if="value && task"
		v-model="value"
		:fullscreen="$vuetify.breakpoint.smAndDown"
		persistent
		max-width="50rem"
	>
		<v-card class="fill">
			<v-toolbar v-if="$vuetify.breakpoint.smAndDown" color="primary">
				<v-btn icon @click.stop="onClose">
					<v-icon>fa-times</v-icon>
				</v-btn>
				<v-toolbar-title>{{ title }}</v-toolbar-title>
				<v-spacer />
				<v-toolbar-items>
					<v-btn text v-if="step > 1" @click.stop="onPrevious">Previous</v-btn>
					<v-btn
						depressed
						v-if="step < 3"
						:disabled="isInvalid"
						@click.stop="onNext"
						color="secondary"
					>Next</v-btn>
					<v-btn
						depressed
						v-if="step >= 3"
						:disabled="isInvalid"
						@click.stop="onSubmit"
						color="secondary"
					>Submit</v-btn>
				</v-toolbar-items>
			</v-toolbar>
			<v-card-title v-else>{{ title }}</v-card-title>

			<v-card-text class="card-text-fill" style="padding: 0;">
				<v-stepper v-model="step" class="tight fill">
					<v-stepper-header>
						<v-stepper-step editable edit-icon="fa-pen" :complete="step > 1" step="1">Describe your task</v-stepper-step>

						<v-stepper-step
							:editable="arePreviousValid(2)"
							edit-icon="fa-pen"
							:complete="step > 2"
							step="2"
						>
							Image and placement
							<small>Optional</small>
						</v-stepper-step>

						<v-stepper-step
							:editable="arePreviousValid(3)"
							edit-icon="fa-pen"
							:complete="step > 3"
							step="3"
						>
							Subtasks
							<small>Optional</small>
						</v-stepper-step>
					</v-stepper-header>

					<v-stepper-content :class="scrollableStepClass" class="tight scrollable-step" step="1">
						<task-dialog-general v-model="task" @check="onFormCheck($event, 1)" />
					</v-stepper-content>

					<v-stepper-content :class="scrollableStepClass" class="tight scrollable-step" step="2">
						<task-dialog-image v-model="task" @check="onFormCheck($event, 2)" />
					</v-stepper-content>

					<v-stepper-content :class="scrollableStepClass" class="tight scrollable-step" step="3">
						<task-dialog-subtasks v-model="task" @check="onFormCheck($event, 3)" />
					</v-stepper-content>
				</v-stepper>
			</v-card-text>

			<v-divider v-if="!$vuetify.breakpoint.smAndDown" />

			<v-card-actions v-if="!$vuetify.breakpoint.smAndDown">
				<v-btn text @click.stop="onClose">Close</v-btn>
				<v-spacer />
				<v-btn v-if="step > 1" @click.stop="onPrevious">Previous</v-btn>
				<v-btn v-if="step < 3" :disabled="isInvalid" @click.stop="onNext" color="accent">Next</v-btn>
				<v-btn v-if="step >= 3" :disabled="isInvalid" @click.stop="onSubmit" color="accent">Submit</v-btn>
			</v-card-actions>
		</v-card>
	</v-dialog>
</template>

<script>
import { Task, priorities } from "@/models/Task";
import taskService from "@/mixins/TaskService";
import TaskDialogGeneral from "@/components/TaskDialogGeneral";
import TaskDialogImage from "@/components/TaskDialogImage";
import TaskDialogSubtasks from "@/components/TaskDialogSubtasks";

const stepDefault = 1;

const defaults = {
	description: "",
	done: false,
	priority: priorities.NORMAL,
	date: Date.now(),
	image: "",
	position: { x: -1, y: -1 },
	subtasks: []
};

export default {
	components: {
		TaskDialogGeneral,
		TaskDialogImage,
		TaskDialogSubtasks
	},

	mixins: [taskService],

	props: {
		value: {
			type: Boolean,
			default: false
		},

		taskId: {
			type: Number,
			default: null
		}
	},

	data() {
		return {
			valid: [false, false, false],
			step: stepDefault,
			task: null
		};
	},

	computed: {
		isInvalid() {
			return !this.valid[this.step - 1];
		},

		title() {
			return (this.taskId ? "Edit" : "Create") + " Task";
		},

		scrollableStepClass() {
			const isMobile = this.$vuetify.breakpoint.smAndDown;
			return {
				"scrollable-step-desktop": !isMobile,
				"scrollable-step-mobile": isMobile
			};
		}
	},

	mounted() {
		this.loadTask()
			.then(t => {
				this.task = t;
			})
			.catch(() => {
				this.task = new Task(
					defaults.description,
					defaults.done,
					defaults.priority,
					defaults.date,
					defaults.image,
					{ ...defaults.position },
					[...defaults.subtasks]
				);
			});
	},

	methods: {
		close() {
			this.$emit("input", false);
		},

		arePreviousValid(step) {
			return this.valid.slice(0, step - 1).reduce((prev, curr) => {
				return prev && curr;
			});
		},

		loadTask() {
			return this.taskService.find(this.taskId);
		},

		createTask() {
			this.taskService.create(this.task);
		},

		updateTask() {
			this.taskService.edit(this.task);
		},

		onClose() {
			this.close();
		},

		onNext() {
			this.step++;
		},

		onPrevious() {
			this.step--;
		},

		onSubmit() {
			if (this.taskId) this.updateTask();
			else this.createTask();
			this.close();
		},

		onFormCheck(event, step) {
			this.$set(this.valid, step - 1, event);
		}
	}
};
</script>

<style lang="scss" scoped>
.tight {
	margin: 0;
	padding: 0;
}

.scrollable-step {
	overflow-y: auto;
}

.scrollable-step-desktop {
	height: 50vh;
}

.scrollable-step-mobile {
	// 100% - toolbar - stepper
	height: calc(100vh - 56px - 72px);
}

card-text-fill {
	// 100% - toolbar
	height: calc(100vh - 56px);
}
</style>
